<template>
    <div class="control-userLastTable wow fadeInUp">
        <div class="text-bold">{{ $t('users.messages.title') }}</div>
        <div class="table-header">
            <div class="table-header--left">
                <div class="text-id">{{ $t('users.messages.id') }}</div>
                <div class="text-id">{{ $t('users.messages.date') }}</div>
                <div class="text-id">{{ $t('users.messages.from') }}</div>
            </div>
            <div class="table-header-center">
                <p class="text-id">{{ $t('users.messages.text') }}</p>
            </div>
            <div class="table-header--right">
                <p class="text-id">{{ $t('users.messages.status') }}</p>
                <p class="text-id">{{ $t('users.messages.edit') }}</p>
            </div>
        </div>
        <div class="table-bodyElement" v-for="message in messages">
            <div class="table-bodyElement--left">
                <p class="text-idBoldBlue">#{{ message.id }}</p>
                <p class="text-id">{{ formatDate(message.created_at) }}</p>
                <p class="text-idBoldBlack">{{ message.user.login }}</p>
            </div>
            <div class="table-bodyElement-center">
                <p class="text-id">{{ message.message }}</p>
            </div>
            <div class="table-bodyElement--right">
                <p class="text-idBlue">{{ message.read ? $t('users.messages.status_read') : $t('users.messages.status_unread') }}</p>
                <div class="box-iconRight">
                    <svg class="deleteIcon" @click="deleteMessage(message.id)">
                        <use xlink:href="/img/sprite.svg#cancel-button"/>
                    </svg>
					<router-link :to="route('tickets_show', {id: message.ticket_id})">
                    <svg class="editIcon">
                        <use xlink:href="/img/sprite.svg#edit"/>
                    </svg>
					</router-link>
                </div>
            </div>
        </div>
        <paginator
            :current-page="currentPage"
            :last-page="lastPage"
            :per-page="perPage"
            :items-count="total"
            @page-changed="setPage"
        />
    </div>
</template>

<script>
	import {mapGetters} from "vuex";
	import route from "../../mixins/route";

    export default {
		name: "ShortMessages",
		mixins: [route],
        props: ['user'],
        data(){
            return {
                currentPage: 0,
                lastPage: 0,
                perPage: 0,
                total: 0,
                page: 1,
                messages: [],
            }
        },
        computed: {
            ...mapGetters([
                'axios'
            ])
        },
        methods: {
            submit(){
                this.axios.get(`users/${this.user.id}/short_messages`, {
                    params: {
                        page: this.page,
                    }
                })
                    .then(resp => resp.data)
                    .then(messages => {
                        console.log(messages);
                        this.currentPage = messages.current_page;
                        this.lastPage = messages.last_page;
                        this.perPage = messages.per_page;
                        this.total = messages.total;
                        this.messages = messages.data;
                    });
            },
            deleteMessage(id){
                this.axios
                    .post(`messages/${id}/delete`)
                    .then(resp => resp.data)
                    .then(data => {
                        if('success' === data.status){
                            this.$swal('Сообщение удалено');
                            this.$root.$emit('reload-messages')
                        }else{
                            this.$swal(this.$t('ui.error'), '', 'error')
                        }
                    });
            },
            setPage(page){
                this.page = page;
                this.submit();
            },
            formatDate(date){
                return this.$date(date).format('DD.MM.YYYY HH:mm:ss');
            },
        },
        mounted(){
            this.submit();
            this.$root.$on('reload-tickets', () => {
                this.setPage(1);
            });
            this.$root.$on('reload-messages', () => {
                this.setPage(1);
            });
        },
	}
</script>

<style scoped>
    .control-userLastTable .table-bodyElement .table-bodyElement-center{
        height: 50px;
    }
    .box-iconRight svg{
        cursor: pointer;
    }
</style>
